#!/usr/bin/env groovy
node {
    stage('Checkout') {
        checkout scm
        def pom = readMavenPom file: 'pom.xml'
        if (pom) {
            echo "Building version ${pom.version}"
        }
        sh "chmod +x ./mvnw"
    }

    stage('Build') {
        parallel 'build': { 
            withEnv(["PATH+jdk=${tool 'Version 14'}/bin"]) {
                sh "./mvnw install -DskipTests"
                archiveArtifacts artifacts: '**/target/*.*'
            }
        }, 'Hello World': {
            echo 'Hello World'
        }
    }

    stage('Unit-Tests') {
        withEnv(["PATH+jdk=${tool 'Version 14'}/bin"]) {
            if (!env.SKIP_TESTS) {
                sh "./mvnw test"
            }
        }
    }

    stage('Sonar') {
        withEnv(["PATH+jdk=${tool 'Version 8'}/bin"]) {
            sh "./mvnw verify sonar:sonar -Dsonar.login=${SONAR_LOGIN}"
        }
    }
}
